import * as React from 'react';
import { Animated, StyleProp, ViewStyle, ImageStyle } from 'react-native';
import { ImageStyle as FastImageStyle, Source } from 'react-native-fast-image';
export interface IProgressiveFastImageProps {
    loadingImageComponent?: React.ReactNode;
    source: Source;
    blurRadius?: number;
    errorSource?: any;
    loadingSource?: any;
    thumbnailSource?: any;
    style?: StyleProp<FastImageStyle>;
    thumbnailImageStyle?: StyleProp<ImageStyle>;
    loadingImageStyle?: StyleProp<FastImageStyle>;
    loadingImageContainerStyle?: StyleProp<ViewStyle>;
    thumbnailAnimationDuration?: number;
    imageAnimationDuration?: number;
    useNativeDriver?: boolean;
    onLoad?: () => void;
    onThumbnailLoad?: () => void;
    onLoadEnd?: () => void;
    onError?: () => void;
}
interface IState {
    imageLoaded: boolean;
    error: boolean;
    showDefault: boolean;
}
declare class ProgressiveImage extends React.Component<IProgressiveFastImageProps, IState> {
    animatedImage: Animated.Value;
    animatedThumbnailImage: Animated.Value;
    animatedLoadingImage: Animated.Value;
    constructor(props: IProgressiveFastImageProps);
    onThumbnailLoad: () => void;
    onImageLoad: () => void;
    onLoadEnd: () => void;
    onError: () => void;
    normalisedSource: () => Source | null;
    statedSource: () => any;
    render(): JSX.Element;
}
export default ProgressiveImage;
